;//////////////////////////////////////////////////////////////////////////////
;   LCD
;//////////////////////////////////////////////////////////////////////////////
; / :
; PA0 -    
; PA1 - 
; PA2 - 
; PA3 -  
; PA4 -  
; PA5 -  
; PA6 -  
; PA7 -  
;
; PC0 - D4(11)LCD
; PC1 - D5(12)LCD
; PC2 - D6(13)LCD
; PC3 - D7(14)LCD
; PC4 - RS(4) LCD
; PC5 - E (6) LCD
; PC6 - 
; PC7 - 
;
; PD0 - 
; PD1 - 
; PD2 - 
; PD3 - 
; PD4 - 
; PD5 - 
; PD6 - 
; PD7 - 
;
; PB0 - 
; PB1 - 
; PB2 - 
; PB3 -  OC0  
; PB4 - 
; PB5 - 
; PB6 - 
; PB7 - 

;//////////////////////////////////////////////////////////////////////////////
.include	"m16def.inc
.def		status	=r2		; SREG
.def		mask	=r3		; 
.def		zero	=r4		;  
.def		one	=r5		;  1
.def		rss	=r6		;  
.def		tmp0	=r13		;
.def		tmp1	=r14		; 
.def		tmp2	=r15		;
.def		temp	=r16		;
.def		temp1	=r17		;
.def		temp2	=r18		;
.def		temp3	=r19		;
.def		temp4	=r20		;
.def		post	=r21		;  
.def		AL	=r22		;
.def		AH	=r23		;
.def		BL	=r24		;
.def		BH	=r25		;
.equ		rambeg	=$0060		; 	
;//////////////////////////////////////////////////////////////////////////////
;osrshadow:	  OSR0
;osrinit_t0:	   OSR0, PWM
;adcinit_m16:	 ADC
;portinit:	 
;lcdreset:	 LCD
;lcdcom:	   LCD
;lcddat:	   LCD
;w100us:	 100 
;w25ms:		 25 
;w01s:		 0.1 c
;w02s:		 0.2 
;bin2bcd16:	 HEX - BCD
;reset:		  
;dsinit:	 DS1820
;dsread:	   DS1820
;dswrite:	   DS1820
;domain:	 
;//////////////////////////////////////////////////////////////////////////////
;.eseg
;.org		$0000			; EEPROM
;//////////////////////////////////////////////////////////////////////////////
.dseg
.org		RAMBEG
;  
watch:		.byte	1		;
;----------------------------
send:		.byte	1		;  . SRAM
;//////////////////////////////////////////////////////////////////////////////
.cseg	
.org		$0000			;Internal Reset Vector Address
		rjmp	reset	
.org		INT0addr		;External Interrupt0 Vector Address
		reti
.org		INT1addr		;External Interrupt1 Vector Address
		reti
.org		OC2addr			;Output Compare2 Interrupt Vector Address
		reti
.org		OVF2addr		;Overflow2 Interrupt Vector Address
		reti
.org		ICP1addr		;Input Capture1 Interrupt Vector Address
		reti
.org		OC1Aaddr		;Output Compare1A Interrupt Vector Address	
		reti
.org		OC1Baddr		;Output Compare1B Interrupt Vector Address
		reti
.org		OVF1addr		;Overflow1 Interrupt Vector Address
		reti
.org		OVF0addr		;Overflow0 Interrupt Vector Address
		rjmp	osrshadow	;OSR
.org		SPIaddr			;SPI Interrupt Vector Address
		reti
.org		URXCaddr		;UART Receive Complete Interrupt Vector Address
		reti
.org		UDREaddr		;UART Data Register Empty Interrupt Vector Address
		reti
.org		UTXCaddr		;UART Transmit Complete Interrupt Vector Address
		reti
.org		ADCCaddr		;ADC Interrupt Vector Address
		reti	        	;ADC
.org		ERDYaddr		;EEPROM Interrupt Vector Address
		reti
.org		ACIaddr			;Analog Comparator Interrupt Vector Address
		reti
.org    	TWIaddr			;Irq. vector address for Two-Wire Interface
		reti
.org		INT2addr		;External Interrupt2 Vector Address
		reti
.org		OC0addr			;Output Compare0 Interrupt Vector Address
		reti
.org		SPMRaddr		;Store Program Memory Ready Interrupt Vector Address
		reti
;//////////////////////////////////////////////////////////////////////////////
;  OSR0
;  :  OVF0addr,POST
;  : ---
;  : --- (  )
;//////////////////////////////////////////////////////////////////////////////
;POST(x,x,x,x,x,x,x,x)
;.equ		x	=1		;1-  PWM
osrshadow:	in	status,SREG
;		sbrc	post,x
;		rcall	oss_x		; 
		out	SREG,status	
		reti
;//////////////////////////////////////////////////////////////////////////////
;  OSR  MEGA16
;  : ----
;  :    OSR
;  : temp
;  : TIMSK,TCCR0,TCNT0
;//////////////////////////////////////////////////////////////////////////////
.equ		shdwcnt	=0		; 
.equ		shdwccr	=1		; /1
osrinit_t0:	
;  oc0
		in	temp,ddrb
		sbr	temp,(1<<pb3)
		out	ddrb,temp
; 
		ldi	temp,0b01111000	;Fast PWM,ComN=3
		ldi	temp1,low(shdwccr)
		andi	temp1,0b00000111;
		or	temp,temp1	;
		out	tccr0,temp	;
; ocie0,  toie0
		in	temp,timsk
		cbr	temp,(1<<ocie0)	;
		sbr	temp,(1<<toie0)	;
		out	timsk,temp
; tcnt0
		ldi	temp,low(shdwcnt); 0
		out	tcnt0,temp	; 
; 
		ldi	temp,$ff
		out	ocr0,temp	;ff-  
		ret
;//////////////////////////////////////////////////////////////////////////////
;  ADC  MEGA16
;   : -  
;  : ---
;  : 
;  : temp
;  : ADCSRA,ADMUX
;//////////////////////////////////////////////////////////////////////////////
.equ		adcddr	=ddra		; 
.equ		adcport	=porta		; ADC
adcinit_m16:	push	temp
; 
		in	temp,adcddr	;
		andi	temp,0b11111110	;1 - 
		out	adcddr,temp	;
		in	temp,adcport	; 
		andi	temp,0b11111110	;
		out	adcport,temp	;  Z		
;   		
;AREF   -  
		ldi	temp,0b01100000	;5v ref,ADC0,adlar.
		out	ADMUX,temp
;     
		ldi	temp,0b10000001	;
		out	ADCSR,temp	;
;  adif
		sbic	ADCSR,adif	;,
		sbi	ADCSR,adif	;, 1
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;  
;//////////////////////////////////////////////////////////////////////////////
portinit:	push 	temp
; A		
		ldi	temp,0b00000000
		out	ddra,temp
		ldi	temp,0b11111000 ; 
		out	porta,temp
; D
		ldi	temp,0b00000000	;
		out	ddrd,temp
		ldi	temp,0b00000000
		out	portd,temp
; C		LCD
; B	
		ldi	temp,0b00000000	; 
		out	ddrb,temp
		ldi	temp,0b00000000
		out	portb,temp
		
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;  LCD
;    
;  : 
; PC0-----D4(11) 			
; PC1-----D5(12)   
; PC2-----D6(13)
; PC3-----D7(14)    
; PC4-----RS(4)     
; PC5-----E (6)
; GND-----RW(5)
; GND-----GND(1)
; VCC-----VCC(2)
;regU-----VD (3)   
;//////////////////////////////////////////////////////////////////////////////		
lcdreset:	push	temp		;   
	; 
		ldi	temp,0b00111111	;DEBUG
		out	ddrc,temp
		ldi	temp,0b00000000
		out	portc,temp
	; LCD	
		ser	temp		;  c
		out	ddrc,temp	;   
		ldi	temp,$28	; 4,2,57
		rcall	lcdcom		;
		rcall	w01s
		ldi	temp,$0c	;  , 
		rcall	lcdcom		;
		rcall	w01s
		ldi	temp,$28	; 4,2,57
		rcall	lcdcom		;
		rcall	w01s
		ldi	temp,$01	;  
		rcall	lcdcom		;
		rcall	w01s
		pop	temp		;  
		ret	
;//////////////////////////////////////////////////////////////////////////////
;    LCD
; temp- 
;//////////////////////////////////////////////////////////////////////////////
lcdcom:		push	temp1		;   
		swap	temp		;    
		push	temp		;    
		andi	temp,$ef	; 
		ori	temp,$e0	;   
		out	portc,r16	;   
		cbi	portc,5		;   
		pop	temp		;  
		swap	temp		;   
		andi	temp,$ef	;
		ori	temp,$e0	;   
		out	portc,temp	;   
		cbi	portc,5		;   
		ldi	temp,24		;   
		ser	temp1		;   1.6 ms
lcdcomw:	dec	temp1		;   
		brne	lcdcomw		; LCD 
		dec	temp		;
		brne	lcdcomw		;
		pop	temp1		;  
		ret 
;//////////////////////////////////////////////////////////////////////////////
;    LCD
; temp- 
;//////////////////////////////////////////////////////////////////////////////
lcddat:		push	temp1		;   
		swap	temp
		push	temp		;  
		ori	temp,$f0		;   
		out	portc,temp	;   
		cbi	portc,5		;   
		pop	temp		;   
		swap	temp		;   
		ori	temp,$f0		;   
		out	portc,temp	;   
		cbi	portc,5		;   
		ldi	temp1,6		;    
		ldi	temp,255		;    
lcddatw:	dec	temp		;    
		brne	lcddatw		;  40 
		dec	temp1		;
		brne	lcddatw		;
		pop	temp1		;   
		ret	
;//////////////////////////////////////////////////////////////////////////////
;  100 
;//////////////////////////////////////////////////////////////////////////////
w100us:		push	temp
		ser	temp
w100us_rew:	dec	temp
		brne	w100us_rew
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;  0.2 
;//////////////////////////////////////////////////////////////////////////////
w02s: 		push	temp
		push	temp1
		push	temp2
		ser	temp
		ser	temp1
		ldi	temp2,8
w02s_rew:	dec	temp
		brne	w02s_rew
		dec	temp1
		brne	w02s_rew
		dec	temp2
		brne	w02s_rew
		pop	temp2
		pop	temp1
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;  0.1 
;//////////////////////////////////////////////////////////////////////////////
w01s:		push	temp
		push	temp1
		push	temp2
		ser	temp
		ser	temp1
		ldi	temp2,4
w01s_rew:	dec	temp
		brne	w01s_rew
		dec	temp1
		brne	w01s_rew
		dec	temp2
		brne	w01s_rew
		pop	temp2
		pop	temp1
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;  25mS 
;//////////////////////////////////////////////////////////////////////////////
w25ms:		push	temp
		push	temp1
		ser	temp
		ser	temp1
w25ms_1:	dec	temp
		brne	w25ms_1
		dec	temp1
		brne	w25ms_1
		pop	temp1
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;  DS1820 (8)
;  :---
;  :temp=$ff->  
;//////////////////////////////////////////////////////////////////////////////
.equ		dsport	=portd		;
.equ		dsddr	=ddrd		; 
.equ		dspin	=pind		;
.equ		dsio	=pd0		;  
dsinit:		sbi	dsddr,dsio	; 
		cbi	dsport,dsio	;  0
		rcall	dswait480	; 480
		cbi	dsddr,dsio	;   Z
		rcall	dswait88	; 88 
		clr	temp		;temp=0
		sbis	dspin,dsio	;  I/O
		ser	temp		;temp=255, DS 
		rcall	dswait480	; 480
		ret
		
dswait480:	push    temp		; 482.88
		push	temp1
		ser	temp
		ldi	temp1,5
dswait480i:	dec	temp
		brne	dswait480i
		dec	temp1
		brne	dswait480i
		pop	temp1
		pop	temp
		ret
		
dswait88:	push	temp		; 88.0
		ldi	temp,231
dswait88i:	dec	temp
		brne	dswait88i
		pop	temp
		ret

;//////////////////////////////////////////////////////////////////////////////
;      DS1820 (8)
;    : temp
;     : temp1
;//////////////////////////////////////////////////////////////////////////////
dsread:		ldi	temp1,0xFF	;   $FF
dswrite:	push	temp3		;   
		ldi	temp3,8		; 8   
dswrite11:	sbi	dsddr,dsio	;
		cbi	dsport,dsio	;  
		rcall	dswait2		; 2 
		ror	temp1		;    
		brcc	dswrite12	; , - 
		cbi	dsddr,dsio	; 
dswrite12:	rcall	dswait9		; 9.8
		clc			; 
		sbic	dspin,dsio	;  
		sec			;=1   =1
		ror	temp		;    
		rcall	dswait48	; 48 
		cbi	dsddr,dsio	; 
		rcall	dswait2		; 2
		dec	temp3		;  -1
		brne	dswrite11	;   
		pop	temp3		; temp3
		ret
		
dswait2:	push	temp		;  2us
		ldi	temp,1
dswait2i:	dec	temp
		nop
		nop
		brne	dswait2i
		pop	temp
		ret
		
dswait9:	push	temp		; 9.6us
		ldi	temp,22
dswait9i:	dec	temp
		brne	dswait9i
		pop	temp
		ret

dswait48:	push	temp		; 48.8us
		ldi	temp,126
dswait48i:	dec	temp
		brne	dswait48i
		pop	temp
		nop
		ret
;//////////////////////////////////////////////////////////////////////////////
;   HEX -> BCD
; B :  X     --tmp0--
; B :    tmp2 tmp1 tmp0	7-4  3-0			    
;               0 6  5 5  3 5 	 3    5
;  : tmp0,tmp1,tmp2
;  : --- (   )
;//////////////////////////////////////////////////////////////////////////////		
bin2bcd16:	push	temp
		push	temp1
		push	xl
		push	xh
		push	zl
		push	zh
		ldi	temp1,16	; 
		clr	tmp2		;temp1- 
		clr	tmp1		; 
		clr	tmp0		; 
		clr	ZH		;
bbcdx_1:	lsl	XL		;  
		rol	XH		;
		rol	tmp0		; 
		rol	tmp1		;
		rol	tmp2		;
		dec	temp1		; 
		brne	bbcdx_2		;  
		pop	zh
		pop	zl
		pop	xh
		pop	xl
		pop	temp1
		pop	temp
		ret			;
bbcdx_2:	ldi	ZL,16		;MSB+1 (15+1)
bbcdx_3:	dec	ZL		; 
		ld	temp,Z		;ld  temp,-z
		subi	temp,-$03	; 
		sbrc	temp,3		;  3  
		st	Z,temp		; 
		ld	temp,Z		;
		subi	temp,-$30	; 
		sbrc	temp,7		;  7  
		st	Z,temp		; 
		cpi	ZL,13		;  ?
		brne	bbcdx_3		;,  
		rjmp	bbcdx_1		;
;//////////////////////////////////////////////////////////////////////////////
;  
;//////////////////////////////////////////////////////////////////////////////
reset:		ldi	temp,low(RAMEND)
		out	SPL,temp
		ldi	temp,high(RAMEND);
		out	SPH,temp	; 
; 
		clr	zero		;  
		ldi	temp,1
		mov	one,temp	;=1
		clr	post		;
; SRAM
		ldi	temp,low(SEND-RAMBEG+1); 9 
		ldi	zl,low(RAMBEG)	; 
		ldi	zh,high(RAMBEG)	; 
initramover:	st	z+,zero		; 
		dec	temp		;
		brne	initramover	; ?
;  SLEEP
		in	temp,MCUCR	; 
		sbr	temp,(1<<se)	;SLEEP 
		cbr	temp,(1<<sm0)	
		cbr	temp,(1<<sm1)
		cbr	temp,(1<<sm2)	; IDLE
;		sbr	temp,(1<<sm)	; POWER DOWN
		out	MCUCR,temp	;
;  :
;		rcall	w02s
; INT0,INT1
;		in	temp,MCUCR
;		cbr	temp,(1<<isc01)+(1<<isc00)
;		cbr	temp,(1<<isc11)+(1<<isc00)
;		out	MCUCR,temp	;  0
;:
		rcall	portinit	;	
		rcall	osrinit_t0	;osr,PWM
		rcall	adcinit_m16	;ADC
		sbi	ACSR,ACD	; 
; 		
;		sbr	x,(1<<x)
; OSR   
		sei
;    
		rcall	w01s		;  
; LCD
             ;       !
			ldi	temp,227 ;  -   
			out	ocr0,temp
			rjmp	lcd45499
;   LCD
	;=0
		clr	temp		; 
		com	temp
		out	ocr0,temp	;  
		com	temp
	; 
lcd123:		sbi	adcsr,adsc	;
	        ; adsc=1?
lcd12353:	sbic	adcsr,adsc	;
		rjmp	lcd12353	;   
	        ; ,   
	        in	temp1,adch	;
	;   
	        cpi	temp1,95	; 
	        brsh	lcd12359
	        rjmp	lcd45499	       
lcd12359:
	;   1     
		cpi	temp,64
		brsh	lcd123591		
		inc 	temp
		com	temp
		out	ocr0,temp	;  
		com	temp
	; 25
lcd123591:      rcall	w01s		;	
		rjmp	lcd123		;  
lcd45499:	rcall	lcdreset	; LCD
		rcall	lcdreset
;//////////////////////////////////////////////////////////////////////////////
;  
;//////////////////////////////////////////////////////////////////////////////
domain:		
r:		rcall	dsinit		; DS1820
		cpi	temp,$ff	;  
		brne	r		;   
		
		ldi	temp1,$cc	;$cc-  ROM 
		rcall	dswrite		;  
		ldi	temp1,$44	;$44-  
		rcall	dswrite
		
d:		rcall	dsread		;   ds
		cpi	temp,$ff	; ?
		brne	d		; -  ( )
		
		rcall	dsinit		;-    
		ldi	temp1,$cc	;$cc-  ROM  
		rcall	dswrite		;  
		ldi	temp1,$be	; scratchpad
		rcall	dswrite		;
		rcall	dsread		;   LSB 
		mov	temp3,temp	; 
		rcall	dsread		;   MSB 
		mov	temp4,temp	; 

;     LCD
	; - LSB
		mov	xl,temp3
		clr	xh
		rcall	bin2bcd16
		ldi	temp,128
		rcall	lcdcom
		mov	temp,tmp1
		andi	temp,0b00001111
		ldi	temp1,$30
		add	temp,temp1
		rcall	lcddat
		mov	temp,tmp0
		swap	temp
		andi	temp,0b00001111
		add	temp,temp1
		rcall	lcddat
		mov	temp,tmp0
		andi	temp,0b00001111
		add	temp,temp1
		rcall	lcddat

    ; - MSB
		mov	xl,temp4
		clr	xh
		rcall	bin2bcd16
		ldi	temp,192
		rcall	lcdcom
		mov	temp,tmp1
		andi	temp,0b00001111
		ldi	temp1,$30
		add	temp,temp1
		rcall	lcddat
		mov	temp,tmp0
		swap	temp
		andi	temp,0b00001111
		add	temp,temp1
		rcall	lcddat
		mov	temp,tmp0
		andi	temp,0b00001111
		add	temp,temp1
		rcall	lcddat
		
;   
;- LSB ( )-   
;   -      0.5 
;     2.   
		lsr	temp3		;  2
		mov	xl,temp3
		clr	xh
		rcall	bin2bcd16
		ldi	temp,134
		rcall	lcdcom
		mov	temp,tmp1
		andi	temp,0b00001111
		ldi	temp1,$30
		add	temp,temp1
		rcall	lcddat
		mov	temp,tmp0
		swap	temp
		andi	temp,0b00001111
		add	temp,temp1
		rcall	lcddat
		mov	temp,tmp0
		andi	temp,0b00001111
		add	temp,temp1
		rcall	lcddat
		
		rjmp	domain
		
f:		rjmp	f
;//////////////////////////////////////////////////////////////////////////////
;    
;//////////////////////////////////////////////////////////////////////////////
programm:	.db	"m16lcd.asm"

	